<?php

namespace App\Http\Controllers;

use App\domain\travelport\FlightOfferPricing;
use Exception;
use Illuminate\Http\Request;
use Illuminate\Http\Response;
use Illuminate\Http\JsonResponse;

class FlightOfferPricingController extends Controller
{
    public function index(Request $request, FlightOfferPricing $flightOfferPricing): JsonResponse
    {
        try {
            $priceResponse = $flightOfferPricing->getPrice(
                $request->input('catalogId'),
                $request->input('products')
            );

            return response()->json($priceResponse);
        } catch (Exception $e) {
            return response()->json([
                'error_message' => $e->getMessage(),
            ], Response::HTTP_BAD_REQUEST);
        }
    }
}
