<?php

namespace App\domain\travelport;

use Exception;
use GuzzleHttp\Exception\GuzzleException;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Storage;

class AddTravelerInWorkbench extends Workbench
{
    protected string $reservationId;
    protected array $traveler;

    public function execute(string $reservationId, array $traveler)
    {
        $this->reservationId = $reservationId;
        $this->traveler = $traveler;
        $response = $this->travelportPost();
        Storage::put('travelport/api/5-reservationworkbench_add_traveler_response.json',json_encode($response, JSON_PRETTY_PRINT));
        return $response;
    }

    public function buildApiUrl(): string
    {
        return "https://{$this->baseURL}/{$this->apiVersion}/air/book/traveler/reservationworkbench/{$this->reservationId}/travelers";
    }

    public function createPayload(): array
    {
        $payload = $this->traveler;
        Storage::put('travelport/api/5-reservationworkbench_add_traveler_request.json', json_encode($payload, JSON_PRETTY_PRINT));
        return  $payload;
    }
}
